=== debian/changelog ===
simbody (3.6.1+dfsg-7) unstable; urgency=high

  * Team upload.
  * libsimbody-dev: Add 'Breaks: libsimbody3.5v5' for smooth upgrades
    from stretch. (Closes: #926358)

 -- Boyuan Yang <byang@debian.org>  Thu, 04 Apr 2019 11:47:09 -0400

simbody (3.6.1+dfsg-6) unstable; urgency=medium

  * Add mips exclusions to the testsuite (timeout errors in buildfarm)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 14 Jan 2019 15:43:30 +0000

simbody (3.6.1+dfsg-5) unstable; urgency=medium

  * Update patch to disable non ending tests on i386
    (Closes: #915630)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sat, 12 Jan 2019 16:21:58 +0000

simbody (3.6.1+dfsg-4) experimental; urgency=medium

  * Add break+replaces over 3.5v5 version (Closes: #915574)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 11 Jan 2019 16:34:41 +0000

simbody (3.6.1+dfsg-3) experimental; urgency=medium

  * More patches to s390 and i386 tests

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Jan 2019 23:20:35 +0000

simbody (3.6.1+dfsg-2) experimental; urgency=medium

  * Patch to compile on BSD/Hurd architectures
  * Disable tests failing on i386 and mips

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Jan 2019 17:02:08 +0000

simbody (3.6.1+dfsg-1) experimental; urgency=medium

  * Update standard version
  * Move pack options to watch file
  * New upstream version 3.6.1+dfsg
    (Closes: #847090, Closes: #830506, Closes:#891871, Closes: #891367)
  * Fix problem with running test without binaries (Closes: #891207)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 17 Oct 2018 15:26:58 +0000
