=== debian/watch ===
version=3
opts=repack,repacksuffix=+dfsg,compression=xz,dversionmangle=s/\+dfsg// \
     https://github.com/simbody/simbody/tags .*/v?Simbody-(\d\S*)\.tar\.gz
